'****************************************************************
'*  Name    : Voeding timer                                     *
'*  Author  : Coenen Stijn [Stynus]                             *
'*  Notice  : Copyright (c) 2009  Elektronica Stynus           *
'*          : All Rights Reserved                               *
'*  Date    : 14/04/2009                                        *
'*  Version : 1.0                                               *
'*  Voor meer info zie:                                         *
'* http://www.schematheek.net/index.php?p=forum/topic&t=109&n=1 *
'****************************************************************
Device  16F84A
Config  WDT_Off, PWRTE_ON, xt_OSC 
XTAL    4
ALL_DIGITAL = true
'****************************************************************
'Pinnen declareren.
'Leds
    Symbol  relais     = PORTA.1 : TRISA.1 = 0
'Schakelaars
    Symbol   down      = PORTA.3 : TRISA.3 = 1
    Symbol   enter     = PORTA.4 : TRISA.4 = 1
    Symbol   up        = PORTA.2 : TRISA.2 = 1
'Lcd
    Declare LCD_DTPIN  PORTB.4
    Declare LCD_ENPIN  PORTB.2
    Declare LCD_RSPIN  PORTB.3
    Declare LCD_INTERFACE    4
    Declare LCD_LINES        2  
'****************************************************************   
'Variabelen declareren
    Dim tijdnummer As Byte
    Dim tijd As Byte 
    Dim index As Byte
'****************************************************************    
Clear
Cls 
DelayMS 300 
Print At 1,1, " SchemaTheek.net "
Print At 2,1, "  Voeding timer  "  
DelayMS 800  
start:
Cls 
DelayMS 300 
tijdnummer = 1
Print At 1,1, " Kies tijd: [1] "
Print At 2,1, "1=3s  2=6s  3=9s"

While 1=1
    Print At 1, 14, Dec tijdnummer
    If up = 0 Then
        tijdnummer = tijdnummer + 1
        If tijdnummer > 3 Then
            tijdnummer = 3
        EndIf 
        While up = 0: Wend
    EndIf
    If down = 0 Then
        tijdnummer = tijdnummer - 1
        If tijdnummer < 1 Then
            tijdnummer = 1
        EndIf 
        While down = 0: Wend
    EndIf
    If enter = 0 Then
        GoTo aftellen
    EndIf
    DelayMS 200    
Wend
aftellen:
    Cls 
    DelayMS 300 
    High relais
    Select tijdnummer
        Case 1
            tijd = 3
        Case 2
            tijd = 6
        Case 3
            tijd = 9
    EndSelect
    For index = tijd To 0 Step -1
        Print At 1,1, "  Uitgang aan" 
        Print At 2,1, " Rest. tijd: ", Dec index
        DelayMS 1000
    Next
    Low relais
GoTo start
'****************************************************************   
End
